#include <iostream.h>
#include <qdir.h>
#include "principal.h"

principal::principal( char *)
                           //  : QDialog(parent,name,FALSE,0)
{

        setCaption("aKtion!");

        config=kapp->getConfig();

        loader = kapp->getIconLoader();
	abrir = new KButton(this, "abrir");
	abrir->setPixmap(loader->loadIcon("fileopen.xpm"));
	QToolTip::add(abrir,i18n("Open file"));
	
	tocar = new KButton(this, "tocar");
	tocar->setPixmap(loader->loadIcon("tocar.xpm"));
	QToolTip::add(tocar,i18n("Play"));
        tocar->setEnabled(false);
	
	parar = new KButton(this, "parar");
	parar->setPixmap(loader->loadIcon("parar.xpm"));
	QToolTip::add(parar,i18n("Stop"));
        parar->setEnabled(false);

	avanzar = new KButton(this, "avanzar");
	avanzar->setPixmap(loader->loadIcon("avanzar.xpm"));
        avanzar->setAutoRepeat( true );
	QToolTip::add(avanzar,i18n("Forward"));
        avanzar->setEnabled(false);

	retroceder = new KButton(this, "retroceder");
	retroceder->setPixmap(loader->loadIcon("retroceder.xpm"));
        retroceder->setAutoRepeat( true );
	QToolTip::add(retroceder,i18n("Backward"));
        retroceder->setEnabled(false);

	ayuda = new KButton(this, "ayuda");
	ayuda->setPixmap(loader->loadIcon("ayuda.xpm"));
	QToolTip::add(ayuda,i18n("Help"));

	configB = new KButton(this, "Setup");
	configB->setPixmap(loader->loadIcon("ak_setup.xpm"));
	QToolTip::add(configB,i18n("Setup"));

	volumeSlider = new QSlider(this);
	volumeSlider->hide();
	volumeSlider->setOrientation(QSlider::Horizontal);
	volumeSlider->setRange(0,100);
	volumeSlider->setSteps(1,20);
	volumeSlider->setTickmarks( QSlider::Right );
	volumeSlider->setTickInterval(10);
	volumeSlider->setTracking(true);
	QToolTip::add(volumeSlider,i18n("Volume"));
	config->setGroup("audio");
        volumeSlider->setValue(config->readNumEntry("audioInitialVolume"));

	line = new QFrame(this, "separator");
        line->setFrameStyle( QFrame::HLine | QFrame::Sunken );

	menu = new QPopupMenu(0L, "menu");
	menu->insertItem(i18n("Video information"),this,SLOT(click_info()) );
	menu->insertSeparator();
	menu->insertItem(loader->loadIcon("fileopen.xpm"),
	                 i18n("Open file..."),this,SLOT(click_open()) );
	menu->insertItem(loader->loadIcon("ak_setup.xpm"),
	                 i18n("Setup..."),this,SLOT(click_config()) );
        menu->insertSeparator();
        menu->insertItem(loader->loadIcon("original.xpm"),
                         i18n("Original size"),this,SLOT(click_original()) );
        menu->insertItem(loader->loadIcon("half.xpm"),
                         i18n("Half size"),this,SLOT(click_half()) );
        menu->insertItem(loader->loadIcon("double.xpm"),
                         i18n("Double size"),this,SLOT(click_double()) );
        menu->insertItem(loader->loadIcon("ak_maximize.xpm"),
                         i18n("Maximized"),this,SLOT(maximize()) );

        video = new KXAnim(this, "video");
        video->move(0,0);
        video->hide();
        video->setAutoResize(false);

        QObject::connect(abrir,SIGNAL(clicked()),
		 this,SLOT(click_open()) );
        QObject::connect(ayuda,SIGNAL(clicked()),
		 this,SLOT(click_ayuda()) );
        QObject::connect(configB,SIGNAL(clicked()),
		 this,SLOT(click_config()) );
        QObject::connect(tocar,SIGNAL(clicked()),
		 this,SLOT(click_play()) );
        QObject::connect(parar,SIGNAL(clicked()),
		 this,SLOT(click_stop()));
        QObject::connect(avanzar,SIGNAL(clicked()),
		 video,SLOT(stepForward()));
        QObject::connect(retroceder,SIGNAL(clicked()),
		 video,SLOT(stepBack()));
        QObject::connect(video,SIGNAL(stopped()),
                 this,SLOT(waitForKXanimExit()) );
        QObject::connect(video,SIGNAL(mouseClick(QMouseEvent *)),
                 this,SLOT(receiveMouseClick(QMouseEvent *)) );
        QObject::connect(volumeSlider,SIGNAL(valueChanged(int)),
                 this,SLOT(volumeSliderMoved(int)) );

        /* set the window's minimum size */
        selectMinimumSize();

        /* set the logo */
        config->setGroup("audio");
        if (config->readBoolEntry("showVolumeSlider")==true)
	   resize(205,177);
	else
           resize(205,130);

        logoWidget = new QWidget( this, "logo");
        logoWidget->setGeometry(0,0,205,122);
        logoWidget->setBackgroundPixmap( loader->loadIcon("aktion.gif") );

        config->setGroup("others");
        lastDir=config->readEntry("initialDirectory");
        if (!QDir(lastDir).exists())
        {
           QMessageBox::information(0L,i18n(i18n("aktion error!")),
                                    i18n("Invalid initial directory"));
	   lastDir="";
        }
        whatToDo=NOTHING;
        parametersChanged=false;
        isNewVideo=false;
        fileName="";
        externalChange=false;
}

principal::~principal()
{
/*	delete parar;
	delete tocar;
	delete abrir;
        delete avanzar;
        delete retroceder;
        delete ayuda;
        delete line;
        delete loader;
        delete configB;
        delete menu;
        delete video;*/
}

void principal::click_original() { changeSize(1.0); };
void principal::click_half()     { changeSize(0.5); };
void principal::click_double()   { changeSize(2.0); };

void principal::changeSize(float zoom)
{
   /* resize the window according to a zoom factor */
   int h,w;
   float zH, zW;

   selectMinimumSize();

   zH=(float)video->getVideoHeight()*zoom;
   zW=(float)video->getVideoWidth()*zoom;
   config->setGroup("audio");
   if (config->readBoolEntry("showVolumeSlider")==true)
   {
      //line   slider   buttons
      h=  2  +   28   +   25    + (int)zH;
   }
   else
      h=2+6+25+(int)zH;

   if (zW<(25*7+15))
      w=25*7+15;
   else
      w=(int)zW;
   
   resize(w,h);
}

void principal::maximize()
{
   /* maximizes the window */
   QRect with_frame, no_frame, result;

   selectMinimumSize();

   with_frame = KWM::geometry(winId(),true);
   no_frame   = KWM::geometry(winId(),false);
   result     = KWM::getWindowRegion( KWM::currentDesktop() );

   result.setWidth( result.width() - (with_frame.width() - no_frame.width()) );
   result.setHeight( result.height() - (with_frame.height() - no_frame.height()) );
   setGeometry( result );
}

void principal::changeInitialSize()
{
   /* this procedure sets the window size just after a video
      has been opened */
   config->setGroup("scaling");
   if (config->readNumEntry("scale")!=3)
   {
      switch (config->readNumEntry("scale"))
      {
         case 0: changeSize(1.0); break;
         case 1: changeSize(0.5); break;
         case 2: changeSize(2.0); break;
      }
   }
   else
   {
      maximize();
   }
}

void principal::dynamicResize()
{
   /* This method is called when the user has selected a config option that
      affects the window size (by now, only showing/hinding the volume slider)
   */
   config->setGroup("audio");
   if (config->readBoolEntry("showVolumeSlider")==false && volumeSlider->isVisible()==true)
   {
      resize(width(),height()-22);
   }
   if (config->readBoolEntry("showVolumeSlider")==true && volumeSlider->isVisible()==false)
   {
      resize(width(),height()+22);
   }
}

void principal::selectMinimumSize()
{
   /* Choses the right minimum size (having in mind the vol. slider */
   int minH=0;

   config->setGroup("audio");
   if (config->readBoolEntry("showVolumeSlider")==true)
   {
      //   line   slider   buttons
      minH=  2  +   28   +   25;
   }
   else
      minH=2+6+25;

   setMinimumSize(25*7+15,minH+1);
}

void principal::waitForKXanimExit()
{
    /* the kxanim's stopped signal activates this slot every time the video
       is stopped. I use the whatToDo switch to know 'what to do now that
       kxanim is stopped'. This is the most secure way to manage the things.
    */
    switch (whatToDo)
    {
        case NOTHING      : break;
        case CLOSE_THE_APP: this->close(); break;
        case NEW_VIDEO    : click_open(); break;
    }
}

void principal::closeEvent( QCloseEvent *e)
{
        if (video->isActive())
        {
            whatToDo=CLOSE_THE_APP;
            video->stop();
            e->ignore();
        }
        else
        {
            kapp->quit();
            e->accept();
        }
}

void principal::click_open()
{
    QString title;
    int pos;
    int return_code=0;

    /* remove the logo picture */
    if (logoWidget != 0L)
    {
       delete logoWidget;
       logoWidget = 0L;
       video->show();
       /* enable the buttons */
       tocar->setEnabled(true);
       parar->setEnabled(true);
       retroceder->setEnabled(true);
       avanzar->setEnabled(true);
    }

    /* the idea behind this method is not very simple:
       if fileName is empty then: get a file name!
       if the video is active (here comes the hard part!):
           set 'what to do' to NEW_VIDEO, stop the video and wait that the
           waitForKXanimExit slot gets activated...
       else
           ok, now that the video is REALLY inactive, we can play with it...!
    */

    if ( fileName.isEmpty() )
        fileName=KFileDialog::getOpenFileName(lastDir,"*.avi *.mov *.mpg *.flc *.fli|All video formats\n"
        					      "*.avi|AVI files (*.avi)\n"
        					      "*.mov|QuickTime files (*.mov)\n"
        					      "*.mpg|MPG Files (*.mpg)\n"
        					      "*.fli *.flc|FLI/FLC Files (*.fli *.flc)\n"
        					      "*|All Files (*)\n"
        				      ,0L,"abrir");
    if (video->isActive() && !fileName.isEmpty() )
    {
        whatToDo=NEW_VIDEO;
        video->stop();
    }
    else
        if (!fileName.isEmpty())
        {
            whatToDo=NOTHING;
            kapp->setOverrideCursor( waitCursor );
            setParameters();
            parametersChanged=false;
            return_code=video->setFile(fileName);
            if (return_code==0)
            {
                changeInitialSize();
                pos=fileName.findRev('/');
                title=fileName.mid(pos+1,fileName.length()-(pos+1));
                // title+=" - aKtion!";
                setCaption( title );
                lastDir=fileName.mid(0,pos+1);
                isNewVideo=true;
                kapp->restoreOverrideCursor();
                click_play();
            }
            else
            {
                kapp->restoreOverrideCursor();
                QMessageBox::information(0L,i18n(i18n("aktion error!")),
                                        video->getErrorString() );
            }
            fileName="";
        }
}

void principal::click_ayuda()
{
    KApplication::getKApplication()->invokeHTMLHelp("aktion/aktion.html","");
}

void principal::click_play()
{
    if (parametersChanged==true && video->isActive()==false)
    {
       setParameters();
       dynamicResize();
       parametersChanged=false;
    }
    config->setGroup("others");
    if (isNewVideo==true && config->readBoolEntry("autoplay")==false)
    {
       video->setPauseAt(0);
    }
    else video->setPauseAt(-1);
    isNewVideo=false;
    if (video->isPlaying()==true)
       tocar->setPixmap(loader->loadIcon("tocar.xpm"));
    else
       tocar->setPixmap(loader->loadIcon("pause.xpm"));
    video->play();
}

void principal::click_stop()
{
   tocar->setPixmap(loader->loadIcon("tocar.xpm"));
   video->stop();
}

void principal::click_config()
{
   Setup dialogo(0L, "setup");
   if (dialogo.exec()==1)
   {
      parametersChanged=true;
      dynamicResize();
   }
}

void principal::setParameters()
{
    config->setGroup("audio");
    video->setAudio(config->readBoolEntry("enable"));
    video->setAudioSync(config->readBoolEntry("audioSync"));
    video->setInitialVolume(volumeSlider->value());

    config->setGroup("color");
    video->setColorAhead(config->readNumEntry("colorAhead"));
    switch (config->readNumEntry("colorMapping"))
    {
       case 0: video->setColorMapping(KXAnim::static332); break;
       case 1: video->setColorMapping(KXAnim::lookupTable); break;
       case 2: video->setColorMapping(KXAnim::grayScale); break;
       case 3: video->setColorMapping(KXAnim::none); break;
    }
    video->setGammaDisplay(float(config->readDoubleNumEntry("gammaDisp")));

    config->setGroup("scaling");
    /* I always wants "resinzing on the fly"

    video->setResizing(true);
    is not necessary 'cause it's true by default.
    */
//    video->setScaleFactor( float(config->readNumEntry("dispFactor"))/100 );
//    video->setScaleFactorB( float(config->readNumEntry("bufFactor"))/100);
    
    config->setGroup("others");
    video->setPreload(config->readBoolEntry("preload"));
    video->setX11Shared(config->readBoolEntry("x11shared"));
    video->setMultiBuffer(config->readBoolEntry("multiBuffer"));
    video->setUsePixmap(config->readBoolEntry("pixmap"));
/*
    switch (config->readNumEntry("visualClass"))
    {
       case 0: video->setX11VisualClass("default"); break;
       case 1: video->setX11VisualClass("staticgray"); break;
       case 2: video->setX11VisualClass("grayscale"); break;
       case 3: video->setX11VisualClass("staticcolor"); break;
       case 4: video->setX11VisualClass("pseudocolor"); break;
       case 5: video->setX11VisualClass("truecolor"); break;
       case 6: video->setX11VisualClass("directcolor"); break;
    }
*/
    video->setLoop(config->readBoolEntry("loop"));
    video->setExtraParameters( config->readEntry("extras"));
}

void principal::keyPressEvent( QKeyEvent *key)
{
   switch(key->key())
   {
      case Key_Space : click_play(); break;
      case Key_Period: video->stepForward(); break;
      case Key_Comma : video->stepBack(); break;
      case Key_Enter : click_open(); break;
      case Key_3     : if(volumeSlider->value() <= 99)
                       {
                          externalChange=true;
                          volumeSlider->setValue( volumeSlider->value() + 1);
                          externalChange=false;
                          video->volumeIncrement();
                       }
                       break;
      case Key_2     : if(volumeSlider->value() >= 1)
                       {
                          externalChange=true;
                          volumeSlider->setValue( volumeSlider->value() - 1);
                          externalChange=false;
                          video->volumeDecrement();
                       }
                       break;
      case Key_F1    : click_ayuda(); break;
      case Key_Escape: this->close(); break;
   }
   key->accept();
}

void principal::receiveMouseClick( QMouseEvent *mouse)
{
   if (mouse->button()==RightButton)
   {
      menu->move(this->x()+mouse->x(),this->y()+mouse->y());
      menu->show();
   }
}

void principal::loadFile( const char *name)
{
   fileName=name;
   click_open();
}

void principal::click_info()
{
   QString s, codec;
   
   codec=video->getVideoCodec();
   s.sprintf("%s: %s\n"
             "%s\n"
             "%dx%d\n"
             "%d %s - %5.2f fps",
             i18n("File"), this->caption(),
             (const char *)codec,
             video->getVideoWidth(),video->getVideoHeight(),
             video->getVideoFrames(),i18n("frames"),video->getVideoSpeed());
   KMsgBox::message(this,"aktion!",s);
}

void principal::volumeSliderMoved(int v)
{
   if (!externalChange)
       video->setVolume(v);
}

void principal::resizeEvent( QResizeEvent *e)
{
        int w=e->size().width();
        int h=e->size().height();
        int extraH=0;
        float video_ar, space_ar, scaled;
        int videoW, videoH;

        /* calculates base height for aKtion controls
             buttons                             */
        h=h-   25;
        config->setGroup("audio");
        if (config->readBoolEntry("showVolumeSlider")==true)
        {
	   extraH=28;
	   volumeSlider->show();
	}
	else
	{
	   extraH=6;
	   volumeSlider->hide();
	}

        abrir->setGeometry(2, h, 25,25);
	tocar->setGeometry(30, h, 25,25);
        parar->setGeometry(56, h, 25,25);
        retroceder->setGeometry(82, h, 25,25);
        avanzar->setGeometry(108, h, 25,25);
        ayuda->setGeometry(w - 26, h, 25,25);
        configB->setGeometry(w - 54, h, 25,25);
        h-=extraH;
        volumeSlider->setGeometry(w - 103, h+2,101,20);
        h-=2;
        line->setGeometry(0,h+2,w,2);

        /* Here comes the resizing-moving process for the video widget.
           It'll maintain his aspect ratio. Steps are:
           .The available space for the video is defined w and h.
           .Resize the video widget as much as possible:
             .Calculate the video and left space aspect ratio.
             .If video aspect ratio is smaller:
                expand in height
              else
                .If video apspect ratio is bigger
                   expand in width
                 else
                   expand all
        */
        videoW=video->getVideoWidth();
        if (videoW==0) videoW=1;
        videoH=video->getVideoHeight();
        if (videoH==0) videoH=1;

        video_ar=(float)videoW/(float)videoH;
        space_ar=(float)w/(float)h;

        if (video_ar<space_ar)
        {
           scaled=(float)videoW*( (float)h/(float)videoH );
           video->resize( (int)scaled,h);
           scaled=((float)w - scaled) /2;
           video->move( (int)scaled, 0);

        }
        else
        {
           if (video_ar>space_ar)
           {
              scaled=(float)videoH*( (float)w/(float)videoW );
              video->resize(w, (int)scaled);
              scaled=((float)h - scaled) /2;
              video->move(0, (int)scaled);
           }
           else
           {
              video->resize(w,h);
              video->move(0,0);
           }
        }
}
#include "principal.moc"
