#ifndef PRINCIPAL_H
#define PRINCIPAL_H

/* Project Specific Includes */
#include "aktionConf.h"
#include "kxanim.h"

/* Library Includes */
#include <qdialog.h>
#include <qevent.h>
#include <qkeycode.h>
#include <qmsgbox.h>
#include <qpixmap.h>
#include <qpopmenu.h>
#include <qrect.h>
#include <qstring.h>
#include <qslider.h>
#include <qtooltip.h>
#include <qwidget.h>
#include <kwm.h>
#include <kapp.h>
#include <ktopwidget.h>
#include <kfiledialog.h>
#include <kiconloader.h>
#include <kbutton.h>
#include <kconfig.h>
#include <kmsgbox.h>
#include <ktopwidget.h>

#define NOTHING       0
#define CLOSE_THE_APP 1
#define NEW_VIDEO     2

class principal : public KTopLevelWidget
{
	 Q_OBJECT
private:
	KButton *parar;
	KButton *tocar;
	KButton *abrir;
	KButton *avanzar;
	KButton *retroceder;
        KButton *ayuda;
        KButton *configB;
        QFrame *line;
        QWidget *logoWidget;
        KXAnim *video;
        KIconLoader *loader;
        QString lastDir;
        QString fileName;
        int whatToDo;
        KConfig *config;
        void changeSize(float);
        void changeInitialSize();
        void dynamicResize();
        void selectMinimumSize();
        void setParameters();
        bool parametersChanged;
        bool isNewVideo;
        QPopupMenu *menu;
        QSlider *volumeSlider;
        bool externalChange;
public:
	principal( char *name=0);
        ~principal();
        void loadFile(const char *);
protected:
        virtual void closeEvent( QCloseEvent *);
        virtual void keyPressEvent( QKeyEvent *);
        virtual void resizeEvent( QResizeEvent *);
signals:
public slots:
        void click_open();
        void click_play();
        void click_stop();
        void click_ayuda();
        void click_config();
        void click_info();
        void click_original();
        void click_half();
        void click_double();
        void waitForKXanimExit();
        void receiveMouseClick( QMouseEvent *);
        void volumeSliderMoved(int);
        void maximize();
};
#endif
